=head1 README

BBBike - ein Programm zum Suchen von Routen für Radfahrer in Berlin

=head1 INSTALLATION

=head2 Download

Die aktuellste BBBike-Archivdatei findet man im Verzeichnis
L<http://sourceforge.net/project/showfiles.php?group_id=19142&package_id=14052> . Die aktuelle Sourcedatei ist
L<http://heanet.dl.sourceforge.net/sourceforge/bbbike/BBBike-3.15.tar.gz> .

=head2 FreeBSD

Für FreeBSD existiert seit 3.0-RELEASE ein I<Port> für BBBike in der
Kategorie B<german>. Besitzer älterer FreeBSD-Versionen können den
I<Port> über L<http://www.freebsd.org/cgi/ports.cgi?query=bbbike&stype=all>
finden. Die Installation über das Ports-System erfolgt wie folgt:

	cd /usr/ports/german/BBBike
	make all install

Ohne I<Port> kann BBBike wie bei L<anderen Unices|/Linux, Solaris, andere Unices> installiert werden.

=head2 Linux, Solaris, andere Unices

Perl5 muss installiert sein. Das ist oft, besonders bei Linux, der
Fall. Mit

	perl -V

kann überprüft werden, ob und welche Version von perl installiert ist.
Ansonsten kann man Perl5 unter L<http://www.perl.com> finden. Es wird
mindestens die Version 5.005 benötigt.

Danach kann BBBike ausgepackt werden:


	zcat BBBike-3.15.tar.gz | tar xfv -

Falls perl/Tk (eine möglichst neue Version, z.B. 800.025 order 804.027) nicht
installiert ist: in das Verzeichnis C<BBBike-3.15>
wechseln und als Superuser


	perl -I`pwd` -MCPAN -e shell
	force install Bundle::BBBike_small
	quit

eingeben, damit Perl/Tk über das
Internet geladen, compiliert und installiert wird. "force" wird
benötigt, da einige Module erwartete Fehler in der Test-Suite erzeugen
und damit die Installation verhindern. Wenn weitere Probleme
auftreten (insbesondere mit der Internet-Verbindung), dann sollten
die Anweisungen in

	perldoc perlmodinstall

befolgt werden, um das Modul Tk manuell zu installieren.

Danach kann mit


	perl bbbike

das Programm gestartet werden. Mit


	perl install.pl

kann optional eine Compilierung von einigen XS-Modulen durchgeführt
werden sowie Einträge für KDE erzeugt werden. Für das Compilieren
ist ein C-Compiler (z.B. gcc), der mittlerweile nicht bei allen
Linux-Versionen standardmäßig installiert wird, notwendig.

Statt Bundle::BBBike_small kann auch Bundle::BBBike verwendet werden.
Damit werden wesentlich mehr Module installiert, die teilweise nur für
die Entwicklung verwendet werden, teilweise aber zusätzliche
BBBike-Features ermöglichen.

Wenn "perl install.pl" nicht verwendet wird, aber trotzdem die
XS-Module für bessere Performance installiert werden sollen, muss

	make ext

ausgeführt werden. Dazu ist das Perl-Modul L<Inline::C> notwendig.

=head2 Windows 95/98/2000/NT/XP

BBBike und Perl benötigen ca. 32 MB an Festplattenspeicher.

Die Datei L<http://heanet.dl.sourceforge.net/sourceforge/bbbike/BBBike-3.14-Windows.exe>
laden und mit WinZip an einer
beliebigen Stelle auf der Festplatte auspacken. Zum Starten von BBBike
muss das Icon C<bbbike.bat> im Verzeichnis BBBike-3.14-Windows
angeklickt werden.

Mit C<setup.bat> kann man optional BBBike nach C<C:\BBBike>
installieren und enthält dann auch einen Eintrag im Startmenü. Nach
der Installation mit C<setup.bat> kann das alte extrahierte Verzeichnis
gelöscht werden.

=head2 Alternative Windows Installation (1)

Alternativ kann BBBike auch nur mit den Sourcen installiert werden.
Arbeitsschritte für Windows-95/98/2000/NT/XP-Benutzer:

=over 4

=item *

Aus dem WWW die perl-Distribution downloaden. Perl kann
von der ActiveState Webpage geladen werden:

L<http://www.activestate.com/Products/ActivePerl/Download.html>



In der Regel werden zwei Dateien zum Installieren benötigt, den
Windows Installer und die eigentliche Perl-Distribution für Windows
Intel. Beide Dateien müssen nacheinander ausgeführt werden. Die
Installation ist normalerweise mit einigen Reboots verbunden.

Nach der Installation von perl muss in der MSDOS-Eingabeafforderung das
Programm


	ppm

aufgerufen werden und mit


	install Tk

über das Internet perl/Tk installiert werden. Mit 


	quit

wird das ppm-Programm verlassen.

=item *

L<BBBike-3.14.tar.gz|http://heanet.dl.sourceforge.net/sourceforge/bbbike/BBBike-3.14-Windows.exe>
downloaden und mit WinZip auspacken. Das
ausgepackte Verzeichnis wird später nicht mehr verschoben.

=item *

In der Eingabeaufforderung oder im Explorer zum Verzeichnis BBBike-3.14
wechseln und


	install.pl

aufrufen. Das Installationsskript erstellt
Einträge für BBBike im Startmenü und erzeugt ein Icon auf dem Desktop.

=back

=head2 Alternative Windows Installation (2)

Wenn Cygwin (L<http://www.cygwin.org/>) installiert ist, können aus einer
cygwin-Shell heraus die Anweisungen wie bei einer
L<UNIX-Installation|/Linux, Solaris, andere Unices>
befolgt werden.

=head2 Alternative Windows Installation (3)

Als weitere Alternative kann eine ältere perl-Distribution, die allerdings Tk
bereits enthält, geladen werden:

L<http://www.perl.com/CPAN/ports/win32/Standard/x86/perl5.00402-bindist04-bc.tar.gz>

Die geladene Datei muss mit WinZip oder gunzip+tar ausgepackt werden.
Im ausgepackten Verzeichnis befindet sich das Installationsprogramm
C<install.bat>. Das Programm in der Eingabeaufforderungen aufrufen und
die Anweisungen befolgen.

Mit dieser alten Version (5.004_02) von Perl benötigt man auch eine
relativ alte Version von BBBike (älter als 3.00).

=head2 Windows 3.1

Windows 3.1 wird nicht mehr unterstützt. Ältere Versionen von BBBike
(z.B. 2.x) haben noch eine Anleitung, wie man BBBike unter Windows 3.1
nutzen kann.


=head2 Mac OS X

Mac OS X enthält bereits perl 5.6.0 oder 5.8.x. Um BBBike zum Laufen zu bringen
werden noch XDarwin und Perl/Tk benötigt. Eine Anleitung zum Aufsetzen
von Perl/Tk auf Mac OS X bekommt man in der comp.lang.perl.tk Newsgroup
(siehe L<http://groups.google.com>).

Folgende Anleitung habe ich von Wolfram Kroll erhalten:

L<http://heanet.dl.sourceforge.net/sourceforge/bbbike/BBBike-3.15.tar.gz> und (von
L<http://www.cpan.org>) perl-5.8.4-stable.tar.gz, Tk-804.027.tar.gz
besorgt.

=over

=item 1.
Perl auf dynamische Libs konfiguriert:

 # sh Configure -des -Duseshrplib
 # make
 # make test
 # sudo make install

--> /usr/local/ ist der default (das orginale perl bleibt erhalten)

=item 2.
Tk: das ist kein Aqua-Tk, sondern für X11, na meinetwegen...

 # make

in einem X11-Fenster: # make test

 sudo make install

=item 3.
bbbike unter X11

läuft!

=back

Um compilieren zu können, sind die Entwicklertools notwendig. Diese
werden "Xcode" genannt und befinden sich entweder auf einer
gleichnamigen CD (bei älteren Macs) oder im Applications-Ordner unter
C<Installers/Xcode Tools/Developer.mpkg> (bei neueren Macs).

Es wird auch eine X11- bzw. Darwin-Umgebung benötigt (X11SDK-Paket). 

Mac OS Classic wird nicht unterstützt.


=head1 AUSFÜHREN

Unter Unix wird BBBike ausgeführt, indem man ins bbbike-Verzeichnis
wechselt und 


	perl bbbike

eintippt. Wenn eine KDE-Installation durchgeführt wurde, findet man
das Icon im 
Startmenü unter dem Punkt "Anwendungen". Bei Windows befindet sich das
BBBike-Icon ebenfalls im Startmenü.

BBBike ist sehr speicher- und CPU-intensiv. Mindestens 16 MB RAM sind
auf i386-Plattformen notwendig (bei Solaris mindestens 32 MB), besser
das doppelte davon. Einige Versionen von BBBike wurden unter folgenden
Plattformen getestet: Solaris-2.5, Solaris 8, FreeBSD-3.5, FreeBSD-4.6, FreeBSD-4.9, Linux Suse 6.4, Linux Suse 7.0, Linux Debian 3.0, Red Hat Linux 8.0, Windows 95, Windows 98, Windows NT 4.0, Windows 2000. Die
Entwicklungsarbeit wird auf einem FreeBSD-Rechner vorgenommen.

=head2 WWW-Version

Im WWW existiert unter der Adresse

L<http://www.bbbike.de>

eine einfache, stark text-orientierte Version von bbbike. Weitere
Informationen zu der CGI-Version gibt es unter

L<http://www.radzeit.de/cgi-bin/bbbike.cgi/info=1>


=head2 Kommandozeilen-Version

Mit C<cbbbike> und C<cmdbbbike> existieren einfache Kommandozeilen-Versionen des
Programms.

=head1 ENTWICKLUNG

Der aktuelle Entwicklungsstand von BBBike kann über CVS
verfolgt werden. Eine ausführliche Anleitung dazu befindet sich unter
L<http://sourceforge.net/cvs/?group_id=19142>.

Von der Kommandozeile muss folgendes eingegeben werden:

    # login ist nur das erste Mal notwendig, Passwort leer lassen
    cvs -d :pserver:anonymous@cvs.sourceforge.net:/cvsroot/bbbike login
    cvs -d :pserver:anonymous@cvs.sourceforge.net:/cvsroot/bbbike co bbbike

    # Alle weiteren Male nur folgendes verwenden:
    cd bbbike
    cvs -q update -d

Das CVS wird fast täglich aktualisiert und enthält auch die aktuellen Daten.

Um nur die Daten zu aktualisieren, kann man sich die aktuellen Daten
als ZIP-Datei von L<http://www.radzeit.de/cgi-bin/bbbike-data.cgi> holen. Die ZIP-Datei
muss im BBBike-Programmverzeichnis (bei Windows unter
C<C:\Programme\BBBike\bbbike>) ausgepackt werden.

=head1 DOKUMENTATION

Die L<Dokumentation|bbbike> liegt im POD-Format (plain old
documentation) in der 
Datei C<bbbike.pod>, sowie als HTML (C<bbbike.html>) vor. Die
POD-Datei kann entweder mit tkpod, perldoc oder aus bbbike (bei
installiertem B<Tk::Pod>) heraus gelesen werden.


=head1 LIZENZ

Die wichtigsten Teilstücke der Anwendung (C<bbbike>, C<cgi/bbbike.cgi>,
C<Strassen.pm> und C<Strassen/Inline.pm>) und die Daten im
C<data>-Verzeichnis sind unter der
L<GPL|http://www.opensource.org/licenses/gpl-license.html>
veröffentlicht. Die restlichen Module können entweder unter der L<Artistic
License|http://www.opensource.org/licenses/artistic-license.html> oder
GPL veröffentlicht werden. Die genauen Lizenzbestimmungen stehen in den
Quelldateien selbst.

Einige Module und Dateien von anderen Autoren sind in dieser
Distribution enthalten: C<lib/your.pm> von Michael G Schwern,
C<lib/Text/ScriptTemplate.pm> von Taisuke Yamada, C<lib/enum.pm> von
Zenin, C<ext/Strassen-Inline/heap.[ch]> der Internet Software
Consortium, C<ext/BBBikeXS/sqrt.c> von Eyal Lebedinsky.

C<BBBike-3.14-Windows.zip> enthält einen Teil der
C<SiePerl>-Distribution.



=head1 AUTOR

Slaven Rezic, E-Mail: L<slaven@rezic.de|mailto:slaven@rezic.de>
